searchNodes=[{"ref":"Mix.Tasks.Openapi.Spec.Json.html","title":"Mix.Tasks.Openapi.Spec.Json","type":"task","doc":"Serialize the given OpenApi spec module to a json file."},{"ref":"Mix.Tasks.Openapi.Spec.Json.html#generate_spec/1","title":"Mix.Tasks.Openapi.Spec.Json.generate_spec/1","type":"function","doc":""},{"ref":"OpenApiSpex.html","title":"OpenApiSpex","type":"module","doc":"Provides the entry-points for defining schemas, validating and casting."},{"ref":"OpenApiSpex.html#cast/3","title":"OpenApiSpex.cast/3","type":"function","doc":"Cast params to conform to a OpenApiSpex.Schema. See OpenApiSpex.Schema.cast/3 for additional examples and details."},{"ref":"OpenApiSpex.html#cast/4","title":"OpenApiSpex.cast/4","type":"function","doc":"Cast all params in Plug.Conn to conform to the schemas for OpenApiSpex.Operation. Returns {:ok, Plug.Conn.t} with params and body_params fields updated if successful, or {:error, reason} if casting fails. content_type may optionally be supplied to select the requestBody schema."},{"ref":"OpenApiSpex.html#cast_and_validate/4","title":"OpenApiSpex.cast_and_validate/4","type":"function","doc":""},{"ref":"OpenApiSpex.html#cast_value/2","title":"OpenApiSpex.cast_value/2","type":"function","doc":"Cast and validate a value against a given Schema."},{"ref":"OpenApiSpex.html#cast_value/3","title":"OpenApiSpex.cast_value/3","type":"function","doc":"Cast and validate a value against a given Schema belonging to a given OpenApi spec."},{"ref":"OpenApiSpex.html#error!/3","title":"OpenApiSpex.error!/3","type":"function","doc":"Raises compile time errors for improperly defined schemas."},{"ref":"OpenApiSpex.html#error_message/1","title":"OpenApiSpex.error_message/1","type":"function","doc":""},{"ref":"OpenApiSpex.html#path_to_string/1","title":"OpenApiSpex.path_to_string/1","type":"function","doc":""},{"ref":"OpenApiSpex.html#resolve_schema/2","title":"OpenApiSpex.resolve_schema/2","type":"function","doc":"Resolve a schema or reference to a schema."},{"ref":"OpenApiSpex.html#resolve_schema_modules/1","title":"OpenApiSpex.resolve_schema_modules/1","type":"function","doc":"Adds schemas to the api spec from the modules specified in the Operations. Eg, if the response schema for an operation is defined with: responses: %{ 200 =&gt; Operation.response(&quot;User&quot;, &quot;application/json&quot;, UserResponse) } Then the UserResponse.schema() function will be called to load the schema, and a Reference to the loaded schema will be used in the operation response. See OpenApiSpex.schema macro for a convenient syntax for defining schema modules."},{"ref":"OpenApiSpex.html#schema/1","title":"OpenApiSpex.schema/1","type":"macro","doc":"Declares a struct based OpenApiSpex.Schema defines the schema/0 callback ensures the schema is linked to the module by &quot;x-struct&quot; extension property defines a struct with keys matching the schema properties defines a @type t for the struct derives a Jason.Encoder and/or Poison.Encoder for the struct See OpenApiSpex.Schema for additional examples and details. Example require OpenApiSpex defmodule User do OpenApiSpex.schema %{ title: &quot;User&quot;, description: &quot;A user of the app&quot;, type: :object, properties: %{ id: %Schema{type: :integer, description: &quot;User ID&quot;}, name: %Schema{type: :string, description: &quot;User name&quot;, pattern: ~r/[a-zA-Z][a-zA-Z0-9_]+/}, email: %Schema{type: :string, description: &quot;Email address&quot;, format: :email}, inserted_at: %Schema{type: :string, description: &quot;Creation timestamp&quot;, format: :&#39;date-time&#39;}, updated_at: %Schema{type: :string, description: &quot;Update timestamp&quot;, format: :&#39;date-time&#39;} }, required: [:name, :email], example: %{ &quot;id&quot; =&gt; 123, &quot;name&quot; =&gt; &quot;Joe User&quot;, &quot;email&quot; =&gt; &quot;joe@gmail.com&quot;, &quot;inserted_at&quot; =&gt; &quot;2017-09-12T12:34:55Z&quot;, &quot;updated_at&quot; =&gt; &quot;2017-09-13T10:11:12Z&quot; } } end"},{"ref":"OpenApiSpex.html#schema_from_map/1","title":"OpenApiSpex.schema_from_map/1","type":"function","doc":"Creates an %OpenApi{} struct from a map. This is useful when importing existing JSON or YAML encoded schemas. Example # Importing an existing JSON encoded schema open_api_spec_from_json = &quot;encoded_schema.json&quot; |&gt; File.read!() |&gt; Jason.decode!() |&gt; OpenApiSpex.OpenApi.Decode.decode() # Importing an existing YAML encoded schema open_api_spec_from_yaml = &quot;encoded_schema.yaml&quot; |&gt; YamlElixir.read_all_from_file!() |&gt; OpenApiSpex.OpenApi.Decode.decode()"},{"ref":"OpenApiSpex.html#validate/3","title":"OpenApiSpex.validate/3","type":"function","doc":"Validate params against OpenApiSpex.Schema. See OpenApiSpex.Schema.validate/3 for examples of error messages."},{"ref":"OpenApiSpex.html#validate/4","title":"OpenApiSpex.validate/4","type":"function","doc":"Validate all params in Plug.Conn against OpenApiSpex.Operation parameter and requestBody schemas. content_type may be optionally supplied to select the requestBody schema."},{"ref":"OpenApiSpex.html#validate_compiled_schema/1","title":"OpenApiSpex.validate_compiled_schema/1","type":"function","doc":"Validate the compiled schema&#39;s properties to ensure the schema is not improperly defined. Only errors which would cause a given schema to always fail should be raised here."},{"ref":"OpenApiSpex.html#validate_compiled_schema/2","title":"OpenApiSpex.validate_compiled_schema/2","type":"function","doc":"Used for validating the schema at compile time, otherwise we&#39;re forced to raise errors for improperly defined schemas at runtime."},{"ref":"OpenApiSpex.Callback.html","title":"OpenApiSpex.Callback","type":"module","doc":"Defines the OpenApiSpex.Callback.t type."},{"ref":"OpenApiSpex.Callback.html#t:t/0","title":"OpenApiSpex.Callback.t/0","type":"type","doc":"Callback Object A map of possible out-of band callbacks related to the parent operation. Each value in the map is a Path Item Object that describes a set of requests that may be initiated by the API provider and the expected responses. The key value used to identify the callback object is an expression, evaluated at runtime, that identifies a URL to use for the callback operation."},{"ref":"OpenApiSpex.Cast.html","title":"OpenApiSpex.Cast","type":"module","doc":""},{"ref":"OpenApiSpex.Cast.html#cast/1","title":"OpenApiSpex.Cast.cast/1","type":"function","doc":""},{"ref":"OpenApiSpex.Cast.html#cast/3","title":"OpenApiSpex.Cast.cast/3","type":"function","doc":"Cast and validate a value against the given schema. Recognizes all the types defined in Open API (itself a superset of JSON Schema). JSON Schema types: https://json-schema.org/latest/json-schema-core.html#rfc.section.4.2.1 Open API primitive types: https://github.com/OAI/OpenAPI-Specification/blob/master/versions/3.0.0.md#data-types For an :object schema type, the cast operation returns a map with atom keys. Examples iex&gt; alias OpenApiSpex.{Cast, Schema} iex&gt; schema = %Schema{type: :string} iex&gt; Cast.cast(schema, &quot;a string&quot;) {:ok, &quot;a string&quot;} iex&gt; Cast.cast(schema, :not_a_string) { :error, [ %OpenApiSpex.Cast.Error{ reason: :invalid_type, type: :string, value: :not_a_string } ] } iex&gt; schema = %Schema{ ...&gt; type: :object, ...&gt; properties: %{ ...&gt; name: nil ...&gt; }, ...&gt; additionalProperties: false ...&gt; } iex&gt; Cast.cast(schema, %{&quot;name&quot; =&gt; &quot;spex&quot;}) {:ok, %{name: &quot;spex&quot;}} iex&gt; Cast.cast(schema, %{&quot;bad&quot; =&gt; &quot;spex&quot;}) { :error, [ %OpenApiSpex.Cast.Error{ name: &quot;bad&quot;, path: [&quot;bad&quot;], reason: :unexpected_field, value: %{&quot;bad&quot; =&gt; &quot;spex&quot;} } ] }"},{"ref":"OpenApiSpex.Cast.html#error/2","title":"OpenApiSpex.Cast.error/2","type":"function","doc":""},{"ref":"OpenApiSpex.Cast.html#ok/1","title":"OpenApiSpex.Cast.ok/1","type":"function","doc":""},{"ref":"OpenApiSpex.Cast.html#success/2","title":"OpenApiSpex.Cast.success/2","type":"function","doc":""},{"ref":"OpenApiSpex.Cast.html#t:schema_or_reference/0","title":"OpenApiSpex.Cast.schema_or_reference/0","type":"type","doc":""},{"ref":"OpenApiSpex.Cast.html#t:t/0","title":"OpenApiSpex.Cast.t/0","type":"type","doc":""},{"ref":"OpenApiSpex.Cast.Discriminator.html","title":"OpenApiSpex.Cast.Discriminator","type":"module","doc":"Defines the OpenApiSpex.Discriminator.t type."},{"ref":"OpenApiSpex.Cast.Discriminator.html#cast/1","title":"OpenApiSpex.Cast.Discriminator.cast/1","type":"function","doc":""},{"ref":"OpenApiSpex.Cast.Discriminator.html#t:t/0","title":"OpenApiSpex.Cast.Discriminator.t/0","type":"type","doc":"Discriminator Object When request bodies or response payloads may be one of a number of different schemas, a discriminator object can be used to aid in serialization, deserialization, and validation. The discriminator is a specific object in a schema which is used to inform the consumer of the specification of an alternative schema based on the value associated with it. A discriminator requires a composite key be set on the schema: allOf oneOf anyOf"},{"ref":"OpenApiSpex.Cast.Error.html","title":"OpenApiSpex.Cast.Error","type":"module","doc":""},{"ref":"OpenApiSpex.Cast.Error.html#message/1","title":"OpenApiSpex.Cast.Error.message/1","type":"function","doc":""},{"ref":"OpenApiSpex.Cast.Error.html#message_with_path/1","title":"OpenApiSpex.Cast.Error.message_with_path/1","type":"function","doc":""},{"ref":"OpenApiSpex.Cast.Error.html#new/2","title":"OpenApiSpex.Cast.Error.new/2","type":"function","doc":""},{"ref":"OpenApiSpex.Cast.Error.html#path_to_string/1","title":"OpenApiSpex.Cast.Error.path_to_string/1","type":"function","doc":""},{"ref":"OpenApiSpex.Cast.Error.html#t:all_of_error/0","title":"OpenApiSpex.Cast.Error.all_of_error/0","type":"type","doc":""},{"ref":"OpenApiSpex.Cast.Error.html#t:any_of_error/0","title":"OpenApiSpex.Cast.Error.any_of_error/0","type":"type","doc":""},{"ref":"OpenApiSpex.Cast.Error.html#t:args/0","title":"OpenApiSpex.Cast.Error.args/0","type":"type","doc":""},{"ref":"OpenApiSpex.Cast.Error.html#t:exclusive_max_error/0","title":"OpenApiSpex.Cast.Error.exclusive_max_error/0","type":"type","doc":""},{"ref":"OpenApiSpex.Cast.Error.html#t:exclusive_min_error/0","title":"OpenApiSpex.Cast.Error.exclusive_min_error/0","type":"type","doc":""},{"ref":"OpenApiSpex.Cast.Error.html#t:invalid_discriminator_value_error/0","title":"OpenApiSpex.Cast.Error.invalid_discriminator_value_error/0","type":"type","doc":""},{"ref":"OpenApiSpex.Cast.Error.html#t:invalid_enum_error/0","title":"OpenApiSpex.Cast.Error.invalid_enum_error/0","type":"type","doc":""},{"ref":"OpenApiSpex.Cast.Error.html#t:invalid_format_error/0","title":"OpenApiSpex.Cast.Error.invalid_format_error/0","type":"type","doc":""},{"ref":"OpenApiSpex.Cast.Error.html#t:invalid_header_error/0","title":"OpenApiSpex.Cast.Error.invalid_header_error/0","type":"type","doc":""},{"ref":"OpenApiSpex.Cast.Error.html#t:invalid_schema_error/0","title":"OpenApiSpex.Cast.Error.invalid_schema_error/0","type":"type","doc":""},{"ref":"OpenApiSpex.Cast.Error.html#t:invalid_type_error/0","title":"OpenApiSpex.Cast.Error.invalid_type_error/0","type":"type","doc":""},{"ref":"OpenApiSpex.Cast.Error.html#t:max_items_error/0","title":"OpenApiSpex.Cast.Error.max_items_error/0","type":"type","doc":""},{"ref":"OpenApiSpex.Cast.Error.html#t:max_length_error/0","title":"OpenApiSpex.Cast.Error.max_length_error/0","type":"type","doc":""},{"ref":"OpenApiSpex.Cast.Error.html#t:max_properties_error/0","title":"OpenApiSpex.Cast.Error.max_properties_error/0","type":"type","doc":""},{"ref":"OpenApiSpex.Cast.Error.html#t:maximum_error/0","title":"OpenApiSpex.Cast.Error.maximum_error/0","type":"type","doc":""},{"ref":"OpenApiSpex.Cast.Error.html#t:min_items_error/0","title":"OpenApiSpex.Cast.Error.min_items_error/0","type":"type","doc":""},{"ref":"OpenApiSpex.Cast.Error.html#t:min_length_error/0","title":"OpenApiSpex.Cast.Error.min_length_error/0","type":"type","doc":""},{"ref":"OpenApiSpex.Cast.Error.html#t:min_properties_error/0","title":"OpenApiSpex.Cast.Error.min_properties_error/0","type":"type","doc":""},{"ref":"OpenApiSpex.Cast.Error.html#t:minimum_error/0","title":"OpenApiSpex.Cast.Error.minimum_error/0","type":"type","doc":""},{"ref":"OpenApiSpex.Cast.Error.html#t:missing_field_error/0","title":"OpenApiSpex.Cast.Error.missing_field_error/0","type":"type","doc":""},{"ref":"OpenApiSpex.Cast.Error.html#t:missing_header_error/0","title":"OpenApiSpex.Cast.Error.missing_header_error/0","type":"type","doc":""},{"ref":"OpenApiSpex.Cast.Error.html#t:multiple_of_error/0","title":"OpenApiSpex.Cast.Error.multiple_of_error/0","type":"type","doc":""},{"ref":"OpenApiSpex.Cast.Error.html#t:no_value_for_discriminator_error/0","title":"OpenApiSpex.Cast.Error.no_value_for_discriminator_error/0","type":"type","doc":""},{"ref":"OpenApiSpex.Cast.Error.html#t:null_value_error/0","title":"OpenApiSpex.Cast.Error.null_value_error/0","type":"type","doc":""},{"ref":"OpenApiSpex.Cast.Error.html#t:one_of_error/0","title":"OpenApiSpex.Cast.Error.one_of_error/0","type":"type","doc":""},{"ref":"OpenApiSpex.Cast.Error.html#t:reason/0","title":"OpenApiSpex.Cast.Error.reason/0","type":"type","doc":""},{"ref":"OpenApiSpex.Cast.Error.html#t:t/0","title":"OpenApiSpex.Cast.Error.t/0","type":"type","doc":""},{"ref":"OpenApiSpex.Cast.Error.html#t:unexpected_field_error/0","title":"OpenApiSpex.Cast.Error.unexpected_field_error/0","type":"type","doc":""},{"ref":"OpenApiSpex.Cast.Error.html#t:unique_items_error/0","title":"OpenApiSpex.Cast.Error.unique_items_error/0","type":"type","doc":""},{"ref":"OpenApiSpex.Cast.String.html","title":"OpenApiSpex.Cast.String","type":"module","doc":"This module will cast a binary to either an Elixir DateTime or Date. Otherwise it will validate a binary based on maxLength, minLength, or a Regex pattern passed through the schema struct."},{"ref":"OpenApiSpex.Cast.String.html#cast/1","title":"OpenApiSpex.Cast.String.cast/1","type":"function","doc":""},{"ref":"OpenApiSpex.Components.html","title":"OpenApiSpex.Components","type":"module","doc":"Defines the OpenApiSpex.Components.t type."},{"ref":"OpenApiSpex.Components.html#t:schemas_map/0","title":"OpenApiSpex.Components.schemas_map/0","type":"type","doc":""},{"ref":"OpenApiSpex.Components.html#t:t/0","title":"OpenApiSpex.Components.t/0","type":"type","doc":"Components Object Holds a set of reusable objects for different aspects of the OAS. All objects defined within the components object will have no effect on the API unless they are explicitly referenced from properties outside the components object."},{"ref":"OpenApiSpex.Contact.html","title":"OpenApiSpex.Contact","type":"module","doc":"Defines the OpenApiSpex.Contact.t type."},{"ref":"OpenApiSpex.Contact.html#t:t/0","title":"OpenApiSpex.Contact.t/0","type":"type","doc":"Contact Object Contact information for the exposed API."},{"ref":"OpenApiSpex.Controller.html","title":"OpenApiSpex.Controller","type":"module","doc":"Generation of OpenAPI documentation via ExDoc documentation and tags. Supported OpenAPI fields description and summary Description of endpoint will be filled with documentation string in the same manner as ExDocs, so first line will be used as a summary and whole documentation will be used as description field. operation_id The action&#39;s operation_id can be set explicitly using a @doc tag. If no operation_id is specified, it will default to the action&#39;s module path: Module.Name.function_name parameters Parameters of the endpoint are defined by :parameters tag which should be map or list that is formed as: [ param_name: definition ] # or [ structure_definition ] Where definition is map or keyword list that accepts the same arguments. Where structure_definition is OpenApiSpex.Parameter.t() or OpenApiSpex.Reference.t() structure that accepts the same arguments. Example: @doc parameters: [ group_id: [in: :path, type: :integer, description: &quot;Group ID&quot;, example: 1] ] or @doc parameters: [ %OpenApiSpex.Parameter{ in: :path, name: :group_id, description: &quot;Group ID&quot;, schema: %Schema{type: :integer}, required: true, example: 1 } ] or @doc parameters: [ &quot;$ref&quot;: &quot;#/components/parameters/group_id&quot; # or %OpenApiSpex.Reference{&quot;$ref&quot;: &quot;#/components/parameters/group_id&quot;} ] responses Responses are controlled by :responses tag. Responses must be defined as a map or keyword list in form of: %{ 200 =&gt; {&quot;Response name&quot;, &quot;application/json&quot;, schema}, :not_found =&gt; {&quot;Response name&quot;, &quot;application/json&quot;, schema} } Or: [ ok: {&quot;Response name&quot;, &quot;application/json&quot;, schema}, not_found: {&quot;Response name&quot;, &quot;application/json&quot;, schema} ] If a response has no body, the definition may be simplified further: [ no_content: &quot;Empty response&quot; ] For each key in the key-value list of map, either an HTTP status code can be used or its atom equivalent. The full set of atom keys are defined in Plug.Conn.Status.code/1. requestBody Controlled by :request_body parameter and is defined as a tuple in form {description, mime, schema} or {description, mime, schema, opts} that matches the arguments of OpenApiSpex.Operation.request_body/3 or OpenApiSpex.Operation.request_body/4, respectively. @doc request_body: { &quot;CartUpdateRequest&quot;, &quot;application/vnd.api+json&quot;, CartUpdateRequest, required: true } security Allows specifying the security scheme(s) required for this operation. See OpenApiSpex.Operation and OpenApiSpex.SecurityRequirement. tags Tags are controlled by :tags attribute. In contrast to other attributes, this one will also inherit all tags defined as a module documentation attributes. Example defmodule UserController do @moduledoc tags: [&quot;Users&quot;] use MyAppWeb, :controller use \#{inspect(__MODULE__)} @doc &quot;&quot;&quot; Endpoint summary Endpoint description... &quot;&quot;&quot; @doc parameters: [ id: [in: :path, type: :string, required: true] ], request_body: {&quot;Request body to update User&quot;, &quot;application/json&quot;, UserUpdateBody, required: true}, responses: [ ok: {&quot;User document&quot;, &quot;application/json&quot;, UserSchema}, {302, &quot;Redirect&quot;, &quot;text/html&quot;, EmptyResponse, headers: %{&quot;Location&quot; =&gt; %Header{description: &quot;Redirect Location&quot;}}} ] def update(conn, %{id: id}) do user_params = conn.body_params # … end end"},{"ref":"OpenApiSpex.ControllerSpecs.html","title":"OpenApiSpex.ControllerSpecs","type":"module","doc":"Macros for defining operation specs, shared operation tags, and shared security specs in a Phoenix controller. Example Here is an example Phoenix controller that uses the ControllerSpecs Operation specs: defmodule MyAppWeb.UserController do use Phoenix.Controller use OpenApiSpex.ControllerSpecs alias MyAppWeb.Schemas.{UserParams, UserResponse} tags [&quot;users&quot;] security [%{}, %{&quot;petstore_auth&quot; =&gt; [&quot;write:users&quot;, &quot;read:users&quot;]}] operation :update, summary: &quot;Update user&quot;, parameters: [ id: [ in: :path, description: &quot;User ID&quot;, type: :integer, example: 1001 ] ], request_body: {&quot;User params&quot;, &quot;application/json&quot;, UserParams}, responses: [ ok: {&quot;User response&quot;, &quot;application/json&quot;, UserResponse} ] def update(conn, %{&quot;id&quot; =&gt; id}) do json(conn, %{ data: %{ id: id, name: &quot;joe user&quot;, email: &quot;joe@gmail.com&quot; } }) end end If you use Elixir Formatter, :open_api_spex can be added to the :import_deps list in the .formatter.exs file of your project to make parentheses of the macros optional."},{"ref":"OpenApiSpex.ControllerSpecs.html#operation/2","title":"OpenApiSpex.ControllerSpecs.operation/2","type":"macro","doc":"Defines an Operation spec for a controller action. Example operation :update, summary: &quot;Update user&quot;, description: &quot;Updates a user record from the given ID path paramter and request body parameters.&quot;, parameters: [ id: [ in: :path, description: &quot;User ID&quot;, type: :integer, example: 1001 ] ], request_body: {&quot;User params&quot;, &quot;application/json&quot;, UserParams}, responses: [ ok: {&quot;User response&quot;, &quot;application/json&quot;, UserResponse} ], security: [%{}, %{&quot;petstore_auth&quot; =&gt; [&quot;write:pets&quot;, &quot;read:pets&quot;]}], tags: [&quot;users&quot;] Options These options correlate to the Operation fields specified in the Open API spec. One difference however, is that the fields defined in Open API use camelCase naming, while the fields used in ControllerSpecs use snake_case to match Elixir&#39;s convention. summary The operation summary parameters The endpoint&#39;s parameters. The syntax for parameters can take multiple forms: The common form is a keyword list, where each key is the parameter name, and the value is a keyword list of options that correlate to the fields in an Open API Parameter Object. For example: parameters: [ id: [ in: :path, description: &quot;User ID&quot;, type: :integer, example: 1001 ] ] A parameters list can also contain references to parameter schemas. There are two ways to do that: parameters: [ &quot;$ref&quot;: &quot;#/components/parameters/user_id&quot; # or %OpenApiSpex.Reference{&quot;$ref&quot;: &quot;#/components/parameters/user_id&quot;} ] request_body The endpoint&#39;s request body. There are multiple ways to specifiy a request body: A three or four-element tuple: request_body: { &quot;User update request body&quot;, &quot;application/json&quot;, UserUpdateRequest, required: true } The tuple consists of the following: The description The content-type An Open API schema. This can be a schema module that implements the OpenApiSpex.Schema behaviour, or an OpenApiSpex.Schema struct. A optional keyword list of options. There is only one option available, and that is required: boolean. responses The endpoint&#39;s responses, for each HTTP status code the endpoint may respond with. Multiple syntaxes are supported: A common syntax is a keyword list, where each key is the textual name of an HTTP status code. For example: [ ok: {&quot;User response&quot;, &quot;application/json&quot;, User}, not_found: {&quot;User not found&quot;, &quot;application/json&quot;, NotFound} ] The list of names and their code mappings is defined in Plug.Conn.Status.code/1. If a map is used, the keys can either be the same atom keys used in the keyword syntax (%{ok: ...}), or they can be integers representing the HTTP status code directly: responses: %{ 200 =&gt; {&quot;User response&quot;, &quot;application/json&quot;, User}, 404 =&gt; {&quot;User not found&quot;, &quot;application/json&quot;, NotFound} } Each response can be a three-element tuple: responses: [ ok: {&quot;User response&quot;, &quot;application/json&quot;, User} # Or ok: {&quot;User response&quot;, &quot;application/json&quot;, %OpenApiSpex.Schema{...}} ] This tuple consists of: A Description string A content-type string An Open API schema. This can be a schema module that implements the OpenApiSpex.Schema behaviour, or an OpenApiSpex.Schema struct. If the response represents an empty response, the definition value can be a single string representing the response description. For example: responses: [ no_content: &quot;Empty response&quot; ] A response can also be defined as an OpenApiSpex.RequestBody struct. In fact, all response body syntaxes resolve to this struct. Additional fields: There are other Operation fields that can be specified that are not described here. See OpenApiSpex.Operation for all the fields."},{"ref":"OpenApiSpex.ControllerSpecs.html#security/1","title":"OpenApiSpex.ControllerSpecs.security/1","type":"macro","doc":"Defines security requirements shared by all operations defined in a controller. See Security Requirement Object spec and OpenApiSpex.SecurityRequirement for more information."},{"ref":"OpenApiSpex.ControllerSpecs.html#tags/1","title":"OpenApiSpex.ControllerSpecs.tags/1","type":"macro","doc":"Defines a list of tags that all operations in a controller will share. Example tags [&quot;users&quot;] All operations defined in the controller will inherit the tags specified by this call. If an operation defines its own tags, the tags in this call will be appended to the operation&#39;s tags."},{"ref":"OpenApiSpex.Discriminator.html","title":"OpenApiSpex.Discriminator","type":"module","doc":"Defines the OpenApiSpex.Discriminator.t type."},{"ref":"OpenApiSpex.Discriminator.html#resolve/3","title":"OpenApiSpex.Discriminator.resolve/3","type":"function","doc":"Resolve the schema that should be used to cast/validate a value using a Discriminator."},{"ref":"OpenApiSpex.Discriminator.html#t:t/0","title":"OpenApiSpex.Discriminator.t/0","type":"type","doc":"Discriminator Object When request bodies or response payloads may be one of a number of different schemas, a discriminator object can be used to aid in serialization, deserialization, and validation. The discriminator is a specific object in a schema which is used to inform the consumer of the specification of an alternative schema based on the value associated with it."},{"ref":"OpenApiSpex.Encoding.html","title":"OpenApiSpex.Encoding","type":"module","doc":"Defines the OpenApiSpex.Encoding.t type."},{"ref":"OpenApiSpex.Encoding.html#t:t/0","title":"OpenApiSpex.Encoding.t/0","type":"type","doc":"Encoding Object A single encoding definition applied to a single schema property."},{"ref":"OpenApiSpex.Example.html","title":"OpenApiSpex.Example","type":"module","doc":"Defines the OpenApiSpex.Example.t type."},{"ref":"OpenApiSpex.Example.html#t:t/0","title":"OpenApiSpex.Example.t/0","type":"type","doc":"Example Object In all cases, the example value is expected to be compatible with the type schema of its associated value."},{"ref":"OpenApiSpex.Extendable.html","title":"OpenApiSpex.Extendable","type":"protocol","doc":""},{"ref":"OpenApiSpex.Extendable.html#to_map/1","title":"OpenApiSpex.Extendable.to_map/1","type":"function","doc":""},{"ref":"OpenApiSpex.Extendable.html#t:t/0","title":"OpenApiSpex.Extendable.t/0","type":"type","doc":""},{"ref":"OpenApiSpex.ExternalDocumentation.html","title":"OpenApiSpex.ExternalDocumentation","type":"module","doc":"Defines the OpenApiSpex.ExternalDocumentation.t type."},{"ref":"OpenApiSpex.ExternalDocumentation.html#t:t/0","title":"OpenApiSpex.ExternalDocumentation.t/0","type":"type","doc":"External Documentation Object Allows referencing an external resource for extended documentation."},{"ref":"OpenApiSpex.Header.html","title":"OpenApiSpex.Header","type":"module","doc":"Defines the OpenApiSpex.Header.t type."},{"ref":"OpenApiSpex.Header.html#t:t/0","title":"OpenApiSpex.Header.t/0","type":"type","doc":"Header Object The Header Object follows the structure of the Parameter Object with the following changes: name MUST NOT be specified, it is given in the corresponding headers map. in MUST NOT be specified, it is implicitly in header. All traits that are affected by the location MUST be applicable to a location of header (for example, style)."},{"ref":"OpenApiSpex.Info.html","title":"OpenApiSpex.Info","type":"module","doc":"Defines the OpenApiSpex.Info.t type."},{"ref":"OpenApiSpex.Info.html#t:t/0","title":"OpenApiSpex.Info.t/0","type":"type","doc":"Info Object The object provides metadata about the API. The metadata MAY be used by the clients if needed, and MAY be presented in editing or documentation generation tools for convenience."},{"ref":"OpenApiSpex.JsonErrorResponse.html","title":"OpenApiSpex.JsonErrorResponse","type":"module","doc":"Schema for the default error renderer used by OpenApiSpex.Plug.CastAndValidate. Examples @doc responses: %{ 201 =&gt; {&quot;User&quot;, &quot;application/json&quot;, UserResponse} 422 =&gt; {&quot;Unprocessable Entity&quot;], &quot;application/json&quot;, OpenApiSpex.JsonApiErrorResponse} }"},{"ref":"OpenApiSpex.JsonErrorResponse.html#response/0","title":"OpenApiSpex.JsonErrorResponse.response/0","type":"function","doc":"Convenience function to return that wraps JsonApiErrorResponse in an Operation response. Examples @doc responses: %{ 201 =&gt; {&quot;User&quot;, &quot;application/json&quot;, UserResponse} 422 =&gt; OpenApiSpex.JsonApiErrorResponse.response() }"},{"ref":"OpenApiSpex.JsonErrorResponse.html#schema/0","title":"OpenApiSpex.JsonErrorResponse.schema/0","type":"function","doc":"A module implementing the OpenApiSpex.Schema behaviour should export a schema/0 function that produces an OpenApiSpex.Schema struct. Callback implementation for OpenApiSpex.Schema.schema/0."},{"ref":"OpenApiSpex.JsonErrorResponse.html#t:t/0","title":"OpenApiSpex.JsonErrorResponse.t/0","type":"type","doc":""},{"ref":"OpenApiSpex.License.html","title":"OpenApiSpex.License","type":"module","doc":"Defines the OpenApiSpex.License.t type."},{"ref":"OpenApiSpex.License.html#t:t/0","title":"OpenApiSpex.License.t/0","type":"type","doc":"License Object License information for the exposed API."},{"ref":"OpenApiSpex.Link.html","title":"OpenApiSpex.Link","type":"module","doc":"Defines the OpenApiSpex.Link.t type."},{"ref":"OpenApiSpex.Link.html#t:t/0","title":"OpenApiSpex.Link.t/0","type":"type","doc":"Link Object The Link object represents a possible design-time link for a response. The presence of a link does not guarantee the caller&#39;s ability to successfully invoke it, rather it provides a known relationship and traversal mechanism between responses and other operations. Unlike dynamic links (i.e. links provided in the response payload), the OAS linking mechanism does not require link information in the runtime response. For computing links, and providing instructions to execute them, a runtime expression is used for accessing values in an operation and using them as parameters while invoking the linked operation."},{"ref":"OpenApiSpex.MediaType.html","title":"OpenApiSpex.MediaType","type":"module","doc":"Defines the OpenApiSpex.MediaType.t type."},{"ref":"OpenApiSpex.MediaType.html#t:t/0","title":"OpenApiSpex.MediaType.t/0","type":"type","doc":"Media Type Object Each Media Type Object provides schema and examples for the media type identified by its key."},{"ref":"OpenApiSpex.OAuthFlow.html","title":"OpenApiSpex.OAuthFlow","type":"module","doc":"Defines the OpenApiSpex.OAuthFlow.t type."},{"ref":"OpenApiSpex.OAuthFlow.html#t:t/0","title":"OpenApiSpex.OAuthFlow.t/0","type":"type","doc":"OAuth Flow Object Configuration details for a supported OAuth Flow"},{"ref":"OpenApiSpex.OAuthFlows.html","title":"OpenApiSpex.OAuthFlows","type":"module","doc":"Defines the OpenApiSpex.OAuthFlows.t type."},{"ref":"OpenApiSpex.OAuthFlows.html#t:t/0","title":"OpenApiSpex.OAuthFlows.t/0","type":"type","doc":"OAuth Flows Object Allows configuration of the supported OAuth Flows."},{"ref":"OpenApiSpex.OpenApi.html","title":"OpenApiSpex.OpenApi","type":"behaviour","doc":"Defines the OpenApiSpex.OpenApi.t type and the behaviour for application modules that construct an OpenApiSpex.OpenApi.t at runtime."},{"ref":"OpenApiSpex.OpenApi.html#from_map/1","title":"OpenApiSpex.OpenApi.from_map/1","type":"function","doc":""},{"ref":"OpenApiSpex.OpenApi.html#json_encoder/0","title":"OpenApiSpex.OpenApi.json_encoder/0","type":"function","doc":""},{"ref":"OpenApiSpex.OpenApi.html#c:spec/0","title":"OpenApiSpex.OpenApi.spec/0","type":"callback","doc":"A spec/0 callback function is required for use with the OpenApiSpex.Plug.PutApiSpec plug. Example @impl OpenApiSpex.OpenApi def spec do %OpenApi{ servers: [ # Populate the Server info from a phoenix endpoint Server.from_endpoint(MyAppWeb.Endpoint) ], info: %Info{ title: &quot;My App&quot;, version: &quot;1.0&quot; }, # populate the paths from a phoenix router paths: Paths.from_router(MyAppWeb.Router) } |&gt; OpenApiSpex.resolve_schema_modules() # discover request/response schemas from path specs end"},{"ref":"OpenApiSpex.OpenApi.html#t:t/0","title":"OpenApiSpex.OpenApi.t/0","type":"type","doc":"OpenAPI Object This is the root document object of the OpenAPI document."},{"ref":"OpenApiSpex.OpenApi.Decode.html","title":"OpenApiSpex.OpenApi.Decode","type":"module","doc":""},{"ref":"OpenApiSpex.OpenApi.Decode.html#decode/1","title":"OpenApiSpex.OpenApi.Decode.decode/1","type":"function","doc":""},{"ref":"OpenApiSpex.Operation.html","title":"OpenApiSpex.Operation","type":"module","doc":"Defines the OpenApiSpex.Operation.t type."},{"ref":"OpenApiSpex.Operation.html#cast/4","title":"OpenApiSpex.Operation.cast/4","type":"function","doc":"Cast params to the types defined by the schemas of the operation parameters and requestBody"},{"ref":"OpenApiSpex.Operation.html#from_plug/2","title":"OpenApiSpex.Operation.from_plug/2","type":"function","doc":"Constructs an Operation struct from plug module and opts"},{"ref":"OpenApiSpex.Operation.html#from_route/1","title":"OpenApiSpex.Operation.from_route/1","type":"function","doc":"Constructs an Operation struct from the plug and opts specified in the given route"},{"ref":"OpenApiSpex.Operation.html#parameter/5","title":"OpenApiSpex.Operation.parameter/5","type":"function","doc":"Shorthand for constructing an OpenApiSpex.Parameter given name, location, type, description and optional examples"},{"ref":"OpenApiSpex.Operation.html#request_body/4","title":"OpenApiSpex.Operation.request_body/4","type":"function","doc":"Shorthand for constructing a RequestBody with description, media_type, schema and optional examples"},{"ref":"OpenApiSpex.Operation.html#response/4","title":"OpenApiSpex.Operation.response/4","type":"function","doc":"Shorthand for constructing a Response with description, media_type, schema and optional examples"},{"ref":"OpenApiSpex.Operation.html#validate/4","title":"OpenApiSpex.Operation.validate/4","type":"function","doc":"Validate params against the schemas of the operation parameters and requestBody"},{"ref":"OpenApiSpex.Operation.html#t:t/0","title":"OpenApiSpex.Operation.t/0","type":"type","doc":"Operation Object Describes a single API operation on a path."},{"ref":"OpenApiSpex.Operation2.html","title":"OpenApiSpex.Operation2","type":"module","doc":"Casts and validates a request from a Plug conn."},{"ref":"OpenApiSpex.Operation2.html#cast/4","title":"OpenApiSpex.Operation2.cast/4","type":"function","doc":""},{"ref":"OpenApiSpex.Parameter.html","title":"OpenApiSpex.Parameter","type":"module","doc":"Defines the OpenApiSpex.Parameter.t type."},{"ref":"OpenApiSpex.Parameter.html#put_schema/2","title":"OpenApiSpex.Parameter.put_schema/2","type":"function","doc":"Sets the schema for a parameter from a simple type, reference or Schema"},{"ref":"OpenApiSpex.Parameter.html#schema/1","title":"OpenApiSpex.Parameter.schema/1","type":"function","doc":"Gets the schema for a parameter, from the schema key or content key, which ever is populated."},{"ref":"OpenApiSpex.Parameter.html#t:location/0","title":"OpenApiSpex.Parameter.location/0","type":"type","doc":"Valid values for the in key in the OpenApiSpex.Parameter struct."},{"ref":"OpenApiSpex.Parameter.html#t:parameters/0","title":"OpenApiSpex.Parameter.parameters/0","type":"type","doc":""},{"ref":"OpenApiSpex.Parameter.html#t:style/0","title":"OpenApiSpex.Parameter.style/0","type":"type","doc":"Valid values for the style key in the OpenApiSpex.Parameter struct."},{"ref":"OpenApiSpex.Parameter.html#t:t/0","title":"OpenApiSpex.Parameter.t/0","type":"type","doc":"Parameter Object Describes a single operation parameter. A unique parameter is defined by a combination of a name and location. Parameter Locations There are four possible parameter locations specified by the in field: path: Used together with Path Templating, where the parameter value is actually part of the operation&#39;s URL. This does not include the host or base path of the API. For example, in /items/{itemId}, the path parameter is itemId. query: Parameters that are appended to the URL. For example, in /items?id=###, the query parameter is id. header: Custom headers that are expected as part of the request. Note that RFC7230 states header names are case insensitive. cookie: Used to pass a specific cookie value to the API."},{"ref":"OpenApiSpex.PathItem.html","title":"OpenApiSpex.PathItem","type":"module","doc":"Defines the OpenApiSpex.PathItem.t type."},{"ref":"OpenApiSpex.PathItem.html#from_routes/1","title":"OpenApiSpex.PathItem.from_routes/1","type":"function","doc":"Builds a PathItem struct from a list of routes that share a path."},{"ref":"OpenApiSpex.PathItem.html#t:route/0","title":"OpenApiSpex.PathItem.route/0","type":"type","doc":"Represents a route from in a Plug/Phoenix application. Eg from the generated __routes__ function in a Phoenix.Router module."},{"ref":"OpenApiSpex.PathItem.html#t:t/0","title":"OpenApiSpex.PathItem.t/0","type":"type","doc":"Path Item Object Describes the operations available on a single path. A Path Item MAY be empty, due to ACL constraints. The path itself is still exposed to the documentation viewer but they will not know which operations and parameters are available."},{"ref":"OpenApiSpex.Paths.html","title":"OpenApiSpex.Paths","type":"module","doc":"Defines the OpenApiSpex.Paths.t type."},{"ref":"OpenApiSpex.Paths.html#from_router/1","title":"OpenApiSpex.Paths.from_router/1","type":"function","doc":"Create a Paths map from the routes in the given router module."},{"ref":"OpenApiSpex.Paths.html#t:path/0","title":"OpenApiSpex.Paths.path/0","type":"type","doc":"Paths Object Holds the relative paths to the individual endpoints and their operations. The path is appended to the URL from the Server Object in order to construct the full URL. The Paths MAY be empty, due to ACL constraints."},{"ref":"OpenApiSpex.Paths.html#t:t/0","title":"OpenApiSpex.Paths.t/0","type":"type","doc":""},{"ref":"OpenApiSpex.Plug.Cache.html","title":"OpenApiSpex.Plug.Cache","type":"behaviour","doc":"Cache for OpenApiSpex Settings: config :open_api_spex, :cache_adapter, Module There are already had three cache adapter: OpenApiSpex.Plug.PersistentTermCache - default OpenApiSpex.Plug.AppEnvCache - if VM not supported persistent_term OpenApiSpex.Plug.NoneCache - none cache If you are constantly modifying specs during development, you can setting like this in dev.exs: config :open_api_spex, :cache_adapter, OpenApiSpex.Plug.NoneCache"},{"ref":"OpenApiSpex.Plug.Cache.html#adapter/0","title":"OpenApiSpex.Plug.Cache.adapter/0","type":"function","doc":"Get cache adapter"},{"ref":"OpenApiSpex.Plug.Cache.html#c:erase/1","title":"OpenApiSpex.Plug.Cache.erase/1","type":"callback","doc":""},{"ref":"OpenApiSpex.Plug.Cache.html#c:get/1","title":"OpenApiSpex.Plug.Cache.get/1","type":"callback","doc":""},{"ref":"OpenApiSpex.Plug.Cache.html#c:put/2","title":"OpenApiSpex.Plug.Cache.put/2","type":"callback","doc":""},{"ref":"OpenApiSpex.Plug.Cache.html#refresh/0","title":"OpenApiSpex.Plug.Cache.refresh/0","type":"function","doc":"Only erase cache, put again when plug starting"},{"ref":"OpenApiSpex.Plug.Cast.html","title":"OpenApiSpex.Plug.Cast","type":"module","doc":"Module plug that will cast the Conn.params and Conn.body_params according to the schemas defined for the operation. Note that when using this plug, the body params are no longer merged into Conn.params and must be read from Conn.body_params separately. The operation_id can be given at compile time as an argument to init: plug OpenApiSpex.Plug.Cast, operation_id: &quot;MyApp.ShowUser&quot; For phoenix applications, the operation_id can be obtained at runtime automatically. defmodule MyAppWeb.UserController do use Phoenix.Controller plug OpenApiSpex.Plug.Cast ... end If you want customize the error response, you can provide the :render_error option to register a plug which creates a custom response in the case of a validation error. Example defmodule MyAppWeb.UserController do use Phoenix.Controller plug OpenApiSpex.Plug.Cast, render_error: MyApp.RenderError ... end defmodule MyApp.RenderError do def init(opts), do: opts def call(conn, reason) do msg = %{error: reason} |&gt; Posion.encode!() conn |&gt; Conn.put_resp_content_type(&quot;application/json&quot;) |&gt; Conn.send_resp(400, msg) end end"},{"ref":"OpenApiSpex.Plug.Cast2.html","title":"OpenApiSpex.Plug.Cast2","type":"module","doc":""},{"ref":"OpenApiSpex.Plug.CastAndValidate.html","title":"OpenApiSpex.Plug.CastAndValidate","type":"module","doc":"Module plug that will cast and validate the Conn.params and Conn.body_params according to the schemas defined for the operation. The operation_id can be given at compile time as an argument to init: plug OpenApiSpex.Plug.CastAndValidate, json_render_error_v2: true, operation_id: &quot;MyApp.ShowUser&quot; For phoenix applications, the operation_id can be obtained at runtime automatically. defmodule MyAppWeb.UserController do use Phoenix.Controller plug OpenApiSpex.Plug.CastAndValidate, json_render_error_v2: true ... end If you want customize the error response, you can provide the :render_error option to register a plug which creates a custom response in the case of a validation error. Example defmodule MyAppWeb.UserController do use Phoenix.Controller plug OpenApiSpex.Plug.CastAndValidate, render_error: MyApp.RenderError ... end defmodule MyApp.RenderError do def init(opts), do: opts def call(conn, reason) do msg = Jason.encode!(%{error: reason}) conn |&gt; Conn.put_resp_content_type(&quot;application/json&quot;) |&gt; Conn.send_resp(400, msg) end end"},{"ref":"OpenApiSpex.Plug.DefaultRenderError.html","title":"OpenApiSpex.Plug.DefaultRenderError","type":"module","doc":""},{"ref":"OpenApiSpex.Plug.JsonRenderErrorV2.html","title":"OpenApiSpex.Plug.JsonRenderErrorV2","type":"module","doc":"Renders errors using a quasi-json:api-compliant data shape. WARNING: Do not use this module directly. It will be renamed in version 4.0 To use this module in a backwards-compatible way, call CastAndValidate like this: plug OpenApiSpex.Plug.CastAndValidate, json_render_error_v2: true"},{"ref":"OpenApiSpex.Plug.PutApiSpec.html","title":"OpenApiSpex.Plug.PutApiSpec","type":"module","doc":"Module plug that calls a given module to obtain the Api Spec and store it as private in the Conn. This allows downstream plugs to use the API spec for casting, validating and rendering. Options module: A module implementing the OpenApiSpex.OpenApi behaviour Example plug OpenApiSpex.Plug.PutApiSpec, module: MyAppWeb.ApiSpec"},{"ref":"OpenApiSpex.Plug.RenderSpec.html","title":"OpenApiSpex.Plug.RenderSpec","type":"module","doc":"Renders the API spec as a JSON response. The API spec must be stored in the conn by OpenApiSpex.Plug.PutApiSpec earlier in the plug pipeline. Example defmodule MyAppWeb.Router do use Phoenix.Router alias MyAppWeb.UserController pipeline :api do plug :accepts, [&quot;json&quot;] plug OpenApiSpex.Plug.PutApiSpec, module: MyAppWeb.ApiSpec end scope &quot;/api&quot; do pipe_through :api resources &quot;/users&quot;, UserController, only: [:create, :index, :show] get &quot;/openapi&quot;, OpenApiSpex.Plug.RenderSpec, [] end end"},{"ref":"OpenApiSpex.Plug.SwaggerUI.html","title":"OpenApiSpex.Plug.SwaggerUI","type":"module","doc":"Module plug that serves SwaggerUI. The full path to the API spec must be given as a plug option. The API spec should be served at the given path, see OpenApiSpex.Plug.RenderSpec Configuring SwaggerUI SwaggerUI can be configured through plug opts. All options will be converted from snake_case to camelCase and forwarded to the SwaggerUIBundle constructor. See the swagger-ui configuration docs for details. Should dynamic configuration be required, the config_url option can be set to an API endpoint that will provide additional config. Example scope &quot;/&quot; do pipe_through :browser # Use the default browser stack get &quot;/&quot;, MyAppWeb.PageController, :index get &quot;/swaggerui&quot;, OpenApiSpex.Plug.SwaggerUI, path: &quot;/api/openapi&quot;, default_model_expand_depth: 3, display_operation_id: true end # Other scopes may use custom stacks. scope &quot;/api&quot; do pipe_through :api resources &quot;/users&quot;, MyAppWeb.UserController, only: [:index, :create, :show] get &quot;/openapi&quot;, OpenApiSpex.Plug.RenderSpec, :show end"},{"ref":"OpenApiSpex.Plug.SwaggerUI.html#init/1","title":"OpenApiSpex.Plug.SwaggerUI.init/1","type":"function","doc":"Initializes the plug. Options :path - Required. The URL path to the API definition. all other opts - forwarded to the SwaggerUIBundle constructor Example get &quot;/swaggerui&quot;, OpenApiSpex.Plug.SwaggerUI, path: &quot;/api/openapi&quot;, default_model_expand_depth: 3, display_operation_id: true"},{"ref":"OpenApiSpex.Plug.Validate.html","title":"OpenApiSpex.Plug.Validate","type":"module","doc":"Module plug that validates params against the schema defined for an operation. If validation fails, the plug will send a 422 response with the reason as the body. This plug should always be run after OpenApiSpex.Plug.Cast, as it expects the params map to have atom keys and query params converted from strings to the appropriate types. Example defmodule MyApp.UserController do use Phoenix.Controller plug OpenApiSpex.Plug.Cast plug OpenApiSpex.Plug.Validate ... end If you want customize the error response, you can provide the :render_error option to register a plug which creates a custom response in the case of a validation error. Example defmodule MyApp.UserController do use Phoenix.Controller plug OpenApiSpex.Plug.Cast plug OpenApiSpex.Plug.Validate, render_error: MyApp.RenderError def render_error(conn, reason) do msg = %{error: reason} |&gt; Posion.encode!() conn |&gt; Conn.put_resp_content_type(&quot;application/json&quot;) |&gt; Conn.send_resp(400, msg) end ... end defmodule MyApp.RenderError do def init(opts), do: opts def call(conn, reason) do msg = %{error: reason} |&gt; Posion.encode!() conn |&gt; Conn.put_resp_content_type(&quot;application/json&quot;) |&gt; Conn.send_resp(400, msg) end end"},{"ref":"OpenApiSpex.Plug.Validate.html#render_error/2","title":"OpenApiSpex.Plug.Validate.render_error/2","type":"function","doc":""},{"ref":"OpenApiSpex.Reference.html","title":"OpenApiSpex.Reference","type":"module","doc":"Defines the OpenApiSpex.Reference.t type."},{"ref":"OpenApiSpex.Reference.html#resolve_parameter/2","title":"OpenApiSpex.Reference.resolve_parameter/2","type":"function","doc":""},{"ref":"OpenApiSpex.Reference.html#resolve_request_body/2","title":"OpenApiSpex.Reference.resolve_request_body/2","type":"function","doc":""},{"ref":"OpenApiSpex.Reference.html#resolve_schema/2","title":"OpenApiSpex.Reference.resolve_schema/2","type":"function","doc":"Resolve a Reference to the Schema it refers to. Examples iex&gt; alias OpenApiSpex.{Reference, Schema} ...&gt; schemas = %{&quot;user&quot; =&gt; %Schema{title: &quot;user&quot;, type: :object}} ...&gt; Reference.resolve_schema(%Reference{&quot;$ref&quot;: &quot;#/components/schemas/user&quot;}, schemas) %OpenApiSpex.Schema{type: :object, title: &quot;user&quot;}"},{"ref":"OpenApiSpex.Reference.html#t:t/0","title":"OpenApiSpex.Reference.t/0","type":"type","doc":"Reference Object A simple object to allow referencing other components in the specification, internally and externally. The Reference Object is defined by JSON Reference and follows the same structure, behavior and rules."},{"ref":"OpenApiSpex.RequestBody.html","title":"OpenApiSpex.RequestBody","type":"module","doc":"Defines the OpenApiSpex.RequestBody.t type."},{"ref":"OpenApiSpex.RequestBody.html#t:t/0","title":"OpenApiSpex.RequestBody.t/0","type":"type","doc":"Request Body Object Describes a single request body."},{"ref":"OpenApiSpex.Response.html","title":"OpenApiSpex.Response","type":"module","doc":"Defines the OpenApiSpex.Response.t type."},{"ref":"OpenApiSpex.Response.html#t:t/0","title":"OpenApiSpex.Response.t/0","type":"type","doc":"Response Object Describes a single response from an API Operation, including design-time, static links to operations based on the response."},{"ref":"OpenApiSpex.Responses.html","title":"OpenApiSpex.Responses","type":"module","doc":"Defines teh OpenApiSpex.Responses.t type."},{"ref":"OpenApiSpex.Responses.html#t:t/0","title":"OpenApiSpex.Responses.t/0","type":"type","doc":"Responses Object A container for the expected responses of an operation. The container maps a HTTP response code to the expected response. The documentation is not necessarily expected to cover all possible HTTP response codes because they may not be known in advance. However, documentation is expected to cover a successful operation response and any known errors. The default MAY be used as a default response object for all HTTP codes that are not covered individually by the specification. The Responses Object MUST contain at least one response code, and it SHOULD be the response for a successful operation call."},{"ref":"OpenApiSpex.Schema.html","title":"OpenApiSpex.Schema","type":"behaviour","doc":"Defines the OpenApiSpex.Schema.t type and operations for casting and validating against a schema. The OpenApiSpex.schema macro can be used to declare schemas with an associated struct and JSON Encoder. Examples defmodule MyApp.Schemas do defmodule EmailString do @behaviour OpenApiSpex.Schema def schema do %OpenApiSpex.Schema { title: &quot;EmailString&quot;, type: :string, format: :email } end end defmodule Person do require OpenApiSpex alias OpenApiSpex.{Reference, Schema} OpenApiSpex.schema(%{ type: :object, required: [:name], properties: %{ name: %Schema{type: :string}, address: %Reference{&quot;$ref&quot;: &quot;#/components/schemas/Address&quot;}, age: %Schema{type: :integer, format: :int32, minimum: 0} } }) end defmodule StringDictionary do @behaviour OpenApiSpex.Schema def schema() do %OpenApiSpex.Schema{ type: :object, additionalProperties: %OpenApiSpex.Schema{ type: :string } } end end defmodule PetCommon do require OpenApiSpex alias OpenApiSpex.{Schema, Discriminator} OpenApiSpex.schema(%{ title: &quot;PetCommon&quot;, description: &quot;Properties common to all Pets&quot; type: :object, properties: %{ name: %Schema{type: :string}, petType: %Schema{type: :string} }, required: [:name, :petType] }) end defmodule Cat do require OpenApiSpex alias OpenApiSpex.Schema OpenApiSpex.schema(%{ title: &quot;Cat&quot;, type: :object, description: &quot;A representation of a cat. Note that `Cat` will be used as the discriminator value.&quot;, allOf: [ PetCommon, %Schema{ type: :object, properties: %{ huntingSkill: %Schema{ type: :string, description: &quot;The measured skill for hunting&quot;, default: &quot;lazy&quot;, enum: [&quot;clueless&quot;, &quot;lazy&quot;, &quot;adventurous&quot;, &quot;aggresive&quot;] } }, required: [:huntingSkill] } ] }) end defmodule Dog do require OpenApiSpex alias OpenApiSpex.Schema OpenApiSpex.schema(%{ type: :object, title: &quot;Dog&quot;, description: &quot;A representation of a dog. Note that `Dog` will be used as the discriminator value.&quot;, allOf: [ PetCommon, %Schema { type: :object, properties: %{ packSize: %Schema{ type: :integer, format: :int32, description: &quot;the size of the pack the dog is from&quot;, default: 0, minimum: 0 } }, required: [ :packSize ] } ] }) end defmodule Pet do require OpenApiSpex alias OpenApiSpex.{Schema, Discriminator} OpenApiSpex.schema(%{ title: &quot;Pet&quot;, type: :object, discriminator: %Discriminator{ propertyName: &quot;petType&quot; }, oneOf: [ Cat, Dog ] }) end"},{"ref":"OpenApiSpex.Schema.html#cast/3","title":"OpenApiSpex.Schema.cast/3","type":"function","doc":"Cast a simple value to the elixir type defined by a schema. By default, object types are cast to maps, however if the &quot;x-struct&quot; attribute is set in the schema, the result will be constructed as an instance of the given struct type. Examples iex&gt; OpenApiSpex.Schema.cast(%Schema{type: :integer}, &quot;123&quot;, %{}) {:ok, 123} iex&gt; {:ok, dt = %DateTime{}} = OpenApiSpex.Schema.cast(%Schema{type: :string, format: :&quot;date-time&quot;}, &quot;2018-04-02T13:44:55Z&quot;, %{}) ...&gt; dt |&gt; DateTime.to_iso8601() &quot;2018-04-02T13:44:55Z&quot; Casting Polymorphic Schemas Schemas using discriminator, allOf, oneOf, anyOf are cast using the following rules: If a discriminator is present, cast the properties defined in the base schema, then cast the result using the schema identified by the discriminator. To avoid infinite recursion, the discriminator is only dereferenced if the discriminator property has not already been cast. Cast the properties using each schema listing in allOf. When a property is defined in multiple allOf schemas, it will be cast using the first schema listed containing the property. Cast the value using each schema listed in oneOf, stopping as soon as a sucessful cast is made. Cast the value using each schema listed in anyOf, stopping as soon as a succesful cast is made."},{"ref":"OpenApiSpex.Schema.html#example/1","title":"OpenApiSpex.Schema.example/1","type":"function","doc":"Generate example value from a %Schema{} struct. This is useful as a simple way to generate values for tests. Example: test &quot;create user&quot;, %{conn: conn} do user_request_schema = MyAppWeb.Schemas.UserRequest.schema() req_body = OpenApiSpex.Schema.example(user_request_schema) resp_body = conn |&gt; post(&quot;/users&quot;, req_body) |&gt; json_response(201) assert ... end"},{"ref":"OpenApiSpex.Schema.html#properties/1","title":"OpenApiSpex.Schema.properties/1","type":"function","doc":"Get the names of all properties definied for a schema. Includes all properties directly defined in the schema, and all schemas included in the allOf list."},{"ref":"OpenApiSpex.Schema.html#c:schema/0","title":"OpenApiSpex.Schema.schema/0","type":"callback","doc":"A module implementing the OpenApiSpex.Schema behaviour should export a schema/0 function that produces an OpenApiSpex.Schema struct."},{"ref":"OpenApiSpex.Schema.html#validate/3","title":"OpenApiSpex.Schema.validate/3","type":"function","doc":"Validate a value against a Schema. This expects that the value has already been cast to the appropriate data type. Examples iex&gt; OpenApiSpex.Schema.validate(%OpenApiSpex.Schema{type: :integer, minimum: 5}, 3, %{}) {:error, &quot;#: 3 is smaller than minimum 5&quot;} iex&gt; OpenApiSpex.Schema.validate(%OpenApiSpex.Schema{type: :string, pattern: &quot;(.*)@(.*)&quot;}, &quot;joe@gmail.com&quot;, %{}) :ok iex&gt; OpenApiSpex.Schema.validate(%OpenApiSpex.Schema{type: :string, pattern: &quot;(.*)@(.*)&quot;}, &quot;joegmail.com&quot;, %{}) {:error, &quot;#: Value \\&quot;joegmail.com\\&quot; does not match pattern: (.*)@(.*)&quot;}"},{"ref":"OpenApiSpex.Schema.html#validate/4","title":"OpenApiSpex.Schema.validate/4","type":"function","doc":"See OpenApiSpex.DeprecatedCast.validate/4."},{"ref":"OpenApiSpex.Schema.html#t:data_type/0","title":"OpenApiSpex.Schema.data_type/0","type":"type","doc":"The basic data types supported by openapi. Reference"},{"ref":"OpenApiSpex.Schema.html#t:schemas/0","title":"OpenApiSpex.Schema.schemas/0","type":"type","doc":"Global schemas lookup by name."},{"ref":"OpenApiSpex.Schema.html#t:t/0","title":"OpenApiSpex.Schema.t/0","type":"type","doc":"Schema Object The Schema Object allows the definition of input and output data types. These types can be objects, but also primitives and arrays. This object is an extended subset of the JSON Schema Specification Wright Draft 00. Example alias OpenApiSpex.Schema %Schema{ title: &quot;User&quot;, type: :object, properties: %{ id: %Schema{type: :integer, minimum: 1}, name: %Schema{type: :string, pattern: &quot;[a-zA-Z][a-zA-Z0-9_]+&quot;}, email: %Scheam{type: :string, format: :email}, last_login: %Schema{type: :string, format: :&quot;date-time&quot;} }, required: [:name, :email], example: %{ &quot;name&quot; =&gt; &quot;joe&quot;, &quot;email&quot; =&gt; &quot;joe@gmail.com&quot; } }"},{"ref":"OpenApiSpex.SchemaConsistency.html","title":"OpenApiSpex.SchemaConsistency","type":"module","doc":"Rules of API Schema consistency. If these rules are not followed, tricky run-time bugs may appear. Related issues: #144"},{"ref":"OpenApiSpex.SchemaConsistency.html#warnings/1","title":"OpenApiSpex.SchemaConsistency.warnings/1","type":"function","doc":"Returns a list of compile-time warnings"},{"ref":"OpenApiSpex.SchemaException.html","title":"OpenApiSpex.SchemaException","type":"exception","doc":""},{"ref":"OpenApiSpex.SchemaResolver.html","title":"OpenApiSpex.SchemaResolver","type":"module","doc":"Internal module used to resolve OpenApiSpex.Schema structs from atoms."},{"ref":"OpenApiSpex.SchemaResolver.html#resolve_schema_modules/1","title":"OpenApiSpex.SchemaResolver.resolve_schema_modules/1","type":"function","doc":"Adds schemas to the api spec from the modules specified in the Operations. Eg, if the response schema for an operation is defined with: responses: %{ 200 =&gt; Operation.response(&quot;User&quot;, &quot;application/json&quot;, UserResponse) } Then the UserResponse.schema() function will be called to load the schema, and a Reference to the loaded schema will be used in the operation response. See OpenApiSpex.schema macro for a convenient syntax for defining schema modules."},{"ref":"OpenApiSpex.SecurityRequirement.html","title":"OpenApiSpex.SecurityRequirement","type":"module","doc":"Defines the OpenApiSpex.SecurityRequirement.t type."},{"ref":"OpenApiSpex.SecurityRequirement.html#t:t/0","title":"OpenApiSpex.SecurityRequirement.t/0","type":"type","doc":"Security Requirement Object Lists the required security schemes to execute this operation. The name used for each property MUST correspond to a security scheme declared in the Security Schemes under the Components Object. Security Requirement Objects that contain multiple schemes require that all schemes MUST be satisfied for a request to be authorized. This enables support for scenarios where multiple query parameters or HTTP headers are required to convey security information. When a list of Security Requirement Objects is defined on the Open API object or Operation Object, only one of Security Requirement Objects in the list needs to be satisfied to authorize the request."},{"ref":"OpenApiSpex.SecurityScheme.html","title":"OpenApiSpex.SecurityScheme","type":"module","doc":"Defines the OpenApiSpex.SecurityScheme.t type."},{"ref":"OpenApiSpex.SecurityScheme.html#t:t/0","title":"OpenApiSpex.SecurityScheme.t/0","type":"type","doc":"Security Scheme Object Defines a security scheme that can be used by the operations. Supported schemes are HTTP authentication, an API key (either as a header or as a query parameter), OAuth2&#39;s common flows (implicit, password, application and access code) as defined in RFC6749, and OpenID Connect Discovery."},{"ref":"OpenApiSpex.Server.html","title":"OpenApiSpex.Server","type":"module","doc":"Defines the OpenApiSpex.Server.t type."},{"ref":"OpenApiSpex.Server.html#from_endpoint/1","title":"OpenApiSpex.Server.from_endpoint/1","type":"function","doc":"Builds a Server from a phoenix Endpoint module"},{"ref":"OpenApiSpex.Server.html#from_endpoint/2","title":"OpenApiSpex.Server.from_endpoint/2","type":"function","doc":"Builds a Server from a phoenix Endpoint module"},{"ref":"OpenApiSpex.Server.html#t:t/0","title":"OpenApiSpex.Server.t/0","type":"type","doc":"Server Object An object representing a Server."},{"ref":"OpenApiSpex.ServerVariable.html","title":"OpenApiSpex.ServerVariable","type":"module","doc":"Defines the OpenApiSpex.ServerVariable.t type."},{"ref":"OpenApiSpex.ServerVariable.html#t:t/0","title":"OpenApiSpex.ServerVariable.t/0","type":"type","doc":"Server Variable Object An object representing a Server Variable for server URL template substitution."},{"ref":"OpenApiSpex.Tag.html","title":"OpenApiSpex.Tag","type":"module","doc":"Defines the OpenApiSpex.Tag.t type."},{"ref":"OpenApiSpex.Tag.html#t:t/0","title":"OpenApiSpex.Tag.t/0","type":"type","doc":"Tag Object Adds metadata to a single tag that is used by the Operation Object. It is not mandatory to have a Tag Object per tag defined in the Operation Object instances."},{"ref":"OpenApiSpex.TermType.html","title":"OpenApiSpex.TermType","type":"module","doc":""},{"ref":"OpenApiSpex.TermType.html#type/1","title":"OpenApiSpex.TermType.type/1","type":"function","doc":""},{"ref":"OpenApiSpex.Test.Assertions.html","title":"OpenApiSpex.Test.Assertions","type":"module","doc":"Defines helpers for testing API responses and examples against API spec schemas."},{"ref":"OpenApiSpex.Test.Assertions.html#assert_schema/3","title":"OpenApiSpex.Test.Assertions.assert_schema/3","type":"function","doc":"Asserts that value conforms to the schema with title schema_title in api_spec."},{"ref":"OpenApiSpex.Test.Assertions2.html","title":"OpenApiSpex.Test.Assertions2","type":"module","doc":"Defines helpers for testing API responses and examples against API spec schemas."},{"ref":"OpenApiSpex.Test.Assertions2.html#assert_schema/3","title":"OpenApiSpex.Test.Assertions2.assert_schema/3","type":"function","doc":"Asserts that value conforms to the schema with title schema_title in api_spec."},{"ref":"OpenApiSpex.TestAssertions.html","title":"OpenApiSpex.TestAssertions","type":"module","doc":"Defines helpers for testing API responses and examples against API spec schemas."},{"ref":"OpenApiSpex.TestAssertions.html#assert_schema/3","title":"OpenApiSpex.TestAssertions.assert_schema/3","type":"function","doc":"Asserts that value conforms to the schema with title schema_title in api_spec."},{"ref":"OpenApiSpex.Xml.html","title":"OpenApiSpex.Xml","type":"module","doc":"Defines the OpenApiSpex.Xml.t type."},{"ref":"OpenApiSpex.Xml.html#t:t/0","title":"OpenApiSpex.Xml.t/0","type":"type","doc":"XML Object A metadata object that allows for more fine-tuned XML model definitions. When using arrays, XML element names are not inferred (for singular/plural forms) and the name property SHOULD be used to add that information. See examples for expected behavior."},{"ref":"readme.html","title":"Open API Spex","type":"extras","doc":"Open API Spex Leverage Open API Specification 3 (formerly Swagger) to document, test, validate and explore your Plug and Phoenix APIs. Generate and serve a JSON Open API Spec document from your code Use the spec to cast request params to well defined schema structs Validate params against schemas, eliminate bad requests before they hit your controllers Validate responses against schemas in tests, ensuring your docs are accurate and reliable Explore the API interactively with with SwaggerUI Full documentation available on hexdocs"},{"ref":"readme.html#installation","title":"Open API Spex - Installation","type":"extras","doc":"The package can be installed by adding open_api_spex to your list of dependencies in mix.exs: def deps do [ {:open_api_spex, &quot;~&gt; 3.9&quot;} ] end"},{"ref":"readme.html#generate-spec","title":"Open API Spex - Generate Spec","type":"extras","doc":"Main Spec Start by adding an ApiSpec module to your application to populate an OpenApiSpex.OpenApi struct. defmodule MyAppWeb.ApiSpec do alias OpenApiSpex.{Components, Info, OpenApi, Paths, Server} alias MyAppWeb.{Endpoint, Router} @behaviour OpenApi @impl OpenApi def spec do %OpenApi{ servers: [ # Populate the Server info from a phoenix endpoint Server.from_endpoint(Endpoint) ], info: %Info{ title: &quot;My App&quot;, version: &quot;1.0&quot; }, # Populate the paths from a phoenix router paths: Paths.from_router(Router) } |&gt; OpenApiSpex.resolve_schema_modules() # Discover request/response schemas from path specs end end Or you can use application&#39;s spec value in info: key. info: %Info{ description: Application.spec(:my_app, :description) version: Application.spec(:my_app, :vsn) } Authorization In case your API requires authorization you can add security schemes as part of the components in the main spec. components: %Components{ securitySchemes: %{&quot;authorization&quot; =&gt; %SecurityScheme{type: &quot;http&quot;, scheme: &quot;bearer&quot;}} } Once the security scheme is defined you can declare it. Please note that the key below matches the one defined in the security scheme, in the our example, &quot;authorization&quot;. security: [%{&quot;authorization&quot; =&gt; []}] If you require authorization for all endpoints you can declare the security in the main spec. In case you need authorization only for specific endpoints, or if you are using more than one security scheme, you can declare it as part of each operation. To learn more about the different security schemes please the check the official documentation. Operations For each plug (controller) that will handle API requests, operations need to be defined that the plug/controller will handle. The operations can be defined using moduledoc attributes that are supported in Elixir 1.7 and higher. Note: For projects using Elixir releases, #242 that potentially breaks OpenApiSpex&#39;s integration with your application. See the next section for work-arounds to this issue. defmodule MyAppWeb.UserController do @moduledoc tags: [&quot;users&quot;] use MyAppWeb, :controller use OpenApiSpex.Controller @doc &quot;&quot;&quot; List users &quot;&quot;&quot; @doc responses: %{ 200 =&gt; {&quot;Users&quot;, &quot;application/json&quot;, MyAppWeb.Schema.Users} } def index(conn, _params) do {:ok, users} = MyApp.Users.all() json(conn, users) end @doc &quot;&quot;&quot; Update user &quot;&quot;&quot; @doc parameters: [ id: [in: :query, schema: %OpenApiSpex.Schema{type: :string}, required: true, description: &quot;User ID&quot;] ], request_body: {&quot;Request body to update a User&quot;, &quot;application/json&quot;, User, required: true}, responses: %{ 200 =&gt; {&quot;User&quot;, &quot;application/json&quot;, MyAppWeb.Schema.User} } def update(conn, %{id: id}) do with {:ok, user} &lt;- MyApp.Users.update(conn.body_params) do json(conn, user) end end end There is a convenient shortcut :type for base data types supported by open api @doc parameters: [ id: [in: :query, type: :string, required: true, description: &quot;User ID&quot;] ] The responses can also be defined using keyword list syntax, and the HTTP status codes can be replaced with their text equivalents: @doc responses: [ ok: {&quot;User&quot;, &quot;application/json&quot;, MyAppWeb.Schema.User} unprocessable_entity: {&quot;Bad request parameters&quot;, &quot;application/json&quot;, MyAppWeb.Schema.BadRequestParameters}, not_found: {&quot;Not found&quot;, &quot;application/json&quot;, MyAppWeb.Schema.NotFound} ] The full set of atom keys are defined in Plug.Conn.Status.code/1. If you need to omit the spec for some action then pass false to the generator: @doc false Each definition in a controller action or plug operation is converted to an %OpenApiSpex.Operation{} struct. The definitions are read by your application&#39;s ApiSpec module, which in turn is called from the OpenApiSpex.Plug.PutApiSpex plug on each request. The definitions data is cached, so it does not actually extract the definitions on each request. Note that in the ExDoc-based definitions, the names of the OpenAPI fields follow snake_case naming convention instead of OpenAPI&#39;s (and JSON Schema&#39;s) camelCase convention. Alternatives to ExDoc-Based Operation Specs %Operation{} If the ExDoc-based operation specs don&#39;t provide the flexibiliy you need, the %Operation{} struct and related structs can be used instead. See the example user controller that uses %Operation{} structs For examples of other action operations, see the example web app. Experimental API There is a new, experimental Operation spec API that has the same lightweight syntax as the ExDoc-based API, but without the potentially breaking issue described in issue #242. This new API is described in the OpenApiSpex.ControllerSpecs docs. Schemas Next, declare JSON schema modules for the request and response bodies. In each schema module, call OpenApiSpex.schema/1, passing the schema definition. The schema must have keys described in OpenApiSpex.Schema.t. This will define a %OpenApiSpex.Schema{} struct. This struct is made available from the schema/0 public function, which is generated by OpenApiSpex.schema/1. You may optionally have the data described by the schema turned into a struct linked to the JSON schema by adding &quot;x-struct&quot;: __MODULE__ to the schema. defmodule MyAppWeb.Schemas do alias OpenApiSpex.Schema defmodule User do require OpenApiSpex OpenApiSpex.schema(%{ # The title is optional. It defaults to the last section of the module name. # So the derived title for MyApp.User is &quot;User&quot;. title: &quot;User&quot;, description: &quot;A user of the app&quot;, type: :object, properties: %{ id: %Schema{type: :integer, description: &quot;User ID&quot;}, name: %Schema{type: :string, description: &quot;User name&quot;, pattern: ~r/[a-zA-Z][a-zA-Z0-9_]+/}, email: %Schema{type: :string, description: &quot;Email address&quot;, format: :email}, birthday: %Schema{type: :string, description: &quot;Birth date&quot;, format: :date}, inserted_at: %Schema{ type: :string, description: &quot;Creation timestamp&quot;, format: :&quot;date-time&quot; }, updated_at: %Schema{type: :string, description: &quot;Update timestamp&quot;, format: :&quot;date-time&quot;} }, required: [:name, :email], example: %{ &quot;id&quot; =&gt; 123, &quot;name&quot; =&gt; &quot;Joe User&quot;, &quot;email&quot; =&gt; &quot;joe@gmail.com&quot;, &quot;birthday&quot; =&gt; &quot;1970-01-01T12:34:55Z&quot;, &quot;inserted_at&quot; =&gt; &quot;2017-09-12T12:34:55Z&quot;, &quot;updated_at&quot; =&gt; &quot;2017-09-13T10:11:12Z&quot; } }) end defmodule UserResponse do require OpenApiSpex OpenApiSpex.schema(%{ title: &quot;UserResponse&quot;, description: &quot;Response schema for single user&quot;, type: :object, properties: %{ data: User }, example: %{ &quot;data&quot; =&gt; %{ &quot;id&quot; =&gt; 123, &quot;name&quot; =&gt; &quot;Joe User&quot;, &quot;email&quot; =&gt; &quot;joe@gmail.com&quot;, &quot;birthday&quot; =&gt; &quot;1970-01-01T12:34:55Z&quot;, &quot;inserted_at&quot; =&gt; &quot;2017-09-12T12:34:55Z&quot;, &quot;updated_at&quot; =&gt; &quot;2017-09-13T10:11:12Z&quot; } } }) end end For more examples of schema definitions, see the sample Phoenix app"},{"ref":"readme.html#serve-the-spec","title":"Open API Spex - Serve the Spec","type":"extras","doc":"To serve the API spec from your application, first add the OpenApiSpex.Plug.PutApiSpec plug somewhere in the pipeline. pipeline :api do plug OpenApiSpex.Plug.PutApiSpec, module: MyAppWeb.ApiSpec end Now the spec will be available for use in downstream plugs. The OpenApiSpex.Plug.RenderSpec plug will render the spec as JSON: scope &quot;/api&quot; do pipe_through :api resources &quot;/users&quot;, MyAppWeb.UserController, only: [:create, :index, :show] get &quot;/openapi&quot;, OpenApiSpex.Plug.RenderSpec, [] end"},{"ref":"readme.html#generating-the-spec","title":"Open API Spex - Generating the Spec","type":"extras","doc":"You can write the swagger file to disk using the following Mix task and optionally, for your convenience, create a direct alias: mix openapi.spec.json --spec MyAppWeb.ApiSpec"},{"ref":"readme.html#serve-swagger-ui","title":"Open API Spex - Serve Swagger UI","type":"extras","doc":"Once your API spec is available through a route (see &quot;Serve the Spec&quot;), the OpenApiSpex.Plug.SwaggerUI plug can be used to serve a SwaggerUI interface. The path: plug option must be supplied to give the path to the API spec. All JavaScript and CSS assets are sourced from cdnjs.cloudflare.com, rather than vendoring into this package. scope &quot;/&quot; do pipe_through :browser # Use the default browser stack get &quot;/&quot;, MyAppWeb.PageController, :index get &quot;/swaggerui&quot;, OpenApiSpex.Plug.SwaggerUI, path: &quot;/api/openapi&quot; end scope &quot;/api&quot; do pipe_through :api resources &quot;/users&quot;, MyAppWeb.UserController, only: [:create, :index, :show] get &quot;/openapi&quot;, OpenApiSpex.Plug.RenderSpec, [] end"},{"ref":"readme.html#importing-an-existing-schema-file","title":"Open API Spex - Importing an existing schema file","type":"extras","doc":":warning: This functionality currently converts Strings into Atoms, which makes it potentially vulnerable to DoS attacks. We recommend that you load Open API Schemas from known files during application startup and not dynamically from external sources at runtime. OpenApiSpex has functionality to import an existing schema, casting it into an %OpenApi{} struct. This means you can load a schema that is JSON or YAML encoded. See the example below: # Importing an existing JSON encoded schema open_api_spec_from_json = &quot;encoded_schema.json&quot; |&gt; File.read!() |&gt; Jason.decode!() |&gt; OpenApiSpex.OpenApi.Decode.decode() # Importing an existing YAML encoded schema open_api_spec_from_yaml = &quot;encoded_schema.yaml&quot; |&gt; YamlElixir.read_all_from_file!() |&gt; List.first() |&gt; OpenApiSpex.OpenApi.Decode.decode() You can then use the loaded spec to with OpenApiSpex.cast_and_validate/4, like: {:ok, _} = OpenApiSpex.cast_and_validate( open_api_spec_from_json, # or open_api_spec_from_yaml spec.paths[&quot;/some_path&quot;].post, test_conn, &quot;application/json&quot; )"},{"ref":"readme.html#validating-and-casting-params","title":"Open API Spex - Validating and Casting Params","type":"extras","doc":"OpenApiSpex can automatically validate requests before they reach the controller action function. Or if you prefer, you can explicitly call on OpenApiSpex to cast and validate the params within the controller action. See OpenApiSpex.cast_value/3 for the latter. The rest of this section describes implicit casting and validating the request before it reaches your controller action. First, the plug OpenApiSpex.Plug.PutApiSpec needs to be called in the Router, as described above. Add the OpenApiSpex.Plug.CastAndValidate plug to a controller to validate request parameters and to cast to Elixir types defined by the operation schema. # Phoenix plug OpenApiSpex.Plug.CastAndValidate, json_render_error_v2: true # Plug plug OpenApiSpex.Plug.CastAndValidate, json_render_error_v2: true, operation_id: &quot;UserController.create&quot; The json_render_error_v2: true is a work-around for a bug in the format of the default error renderer. It will be not needed in version 4.0. For Phoenix apps, the operation_id can be inferred from the contents of conn.private. The data shape of the default error renderer follows the JSON:API spec for error responses. For convenience, the OpenApiSpex.JsonErrorResponse schema module is available that specifies the shape, and it can be used in your API specs. Example usage of CastAndValidate in a Phoenix controller: defmodule MyAppWeb.UserController do use MyAppWeb, :controller alias OpenApiSpex.Operation alias MyAppWeb.Schemas.{User, UserRequest, UserResponse} plug OpenApiSpex.Plug.CastAndValidate, json_render_error_v2: true @doc &quot;&quot;&quot; Create user. Create a user. &quot;&quot;&quot; @doc parameters: [ id: [in: :query, type: :integer, description: &quot;user ID&quot;] ], request_body: {&quot;The user attributes&quot;, &quot;application/json&quot;, UserRequest}, responses: %{ 201 =&gt; {&quot;User&quot;, &quot;application/json&quot;, UserResponse} 422 =&gt; OpenApiSpex.JsonErrorResponse.response() } def create( conn = %{ body_params: %UserRequest{ user: %User{name: name, email: email, birthday: birthday = %Date{}} } }, %{id: id} ) do # conn.body_params cast to UserRequest struct # conn.params.id cast to integer end end Now the client will receive a 422 response whenever the request fails to meet the validation rules from the api spec. The response body will include the validation error message: { &quot;errors&quot;: [ { &quot;detail&quot;: &quot;Invalid format. Expected :date&quot;, &quot;source&quot;: { &quot;pointer&quot;: &quot;/data/birthday&quot; }, &quot;title&quot;: &quot;Invalid value&quot; } ] } If you would like a different response JSON shape, create a plug module to shape the response, and pass it to CastAndValidate: plug OpenApiSpex.Plug.CastAndValidate, render_error: MyErrorRendererPlug defmodule MyErrorRendererPlug do @behaviour Plug alias Plug.Conn alias OpenApiSpex.OpenApi @impl Plug def init(errors), do: errors @impl Plug def call(conn, errors) when is_list(errors) do response = %{ errors: Enum.map(errors, &amp;to_string/1) } json = OpenApi.json_encoder().encode!(response) conn |&gt; Conn.put_resp_content_type(&quot;application/json&quot;) |&gt; Conn.send_resp(422, json) end end"},{"ref":"readme.html#generate-examples","title":"Open API Spex - Generate Examples","type":"extras","doc":"OpenApiSpex can generate example data from specs. This has a similar result as SwaggerUI when it generates example requests or responses for an endpoint. Generated examples are a convenient way to come up with test data for controller/plug tests. use MyAppWeb.ConnCase test &quot;create/2&quot;, %{conn: conn} do request_body = OpenApiSpex.Schema.example(MyAppWeb.Schemas.UserRequest.schema()) json = conn |&gt; post(user_path(conn), request_body) |&gt; json_response(200) end"},{"ref":"readme.html#validate-examples","title":"Open API Spex - Validate Examples","type":"extras","doc":"As schemas evolve, you may want to confirm that the examples given match the schemas. Use the OpenApiSpex.TestAssertions module to assert on schema validations. use ExUnit.Case import OpenApiSpex.TestAssertions test &quot;UsersResponse example matches schema&quot; do api_spec = MyAppWeb.ApiSpec.spec() schema = MyAppWeb.Schemas.UsersResponse.schema() assert_schema(schema.example, &quot;UsersResponse&quot;, api_spec) end"},{"ref":"readme.html#validate-responses","title":"Open API Spex - Validate Responses","type":"extras","doc":"API responses can be tested against schemas using OpenApiSpex.TestAssertions also: use MyAppWeb.ConnCase import OpenApiSpex.TestAssertions test &quot;UserController produces a UsersResponse&quot;, %{conn: conn} do json = conn |&gt; get(user_path(conn, :index)) |&gt; json_response(200) api_spec = MyAppWeb.ApiSpec.spec() assert_schema(json, &quot;UsersResponse&quot;, api_spec) end"}]